moSetGetExtras = {};

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;


--new LS 19
--ls 19 intern optional --> g_currentMission.environment:addMinuteChangeListener(self) --check your Table at environment 
function moSetGetExtras:addTimer(...) ---> table with optional values
	if MultiOverlayV3.timers == nil then MultiOverlayV3.timers = {};end;
	if ... ~= nil and type(...) == "table" then		
		local args = ...;				
		local delayMs = 1*100; -->1 mSec		
		local delay = 1*1000; -->default is 1 sec
		local action = nil;
		local repeatable = true; -->default endless (optional false=1x or integer for max runs)
		local timerReady = false;		
		for arg, value in pairs(args) do
			if arg == "ms" and type(args.ms) == "boolean" and args.ms then delay = delayMs;end;
			if arg == "delay" and type(args.delay) == "number" and args.delay > 1 then delay = args.delay*delay;end;
			if arg == "action" and type(args.action) == "function" then action = args.action;end;			
			if arg == "repeatable" and (type(args.repeatable) == "number" or type(args.repeatable) == "boolean") then repeatable = args.repeatable;end;
			if arg == "name" and type(args.name) == "string" and MultiOverlayV3.timers[args.name] == nil then				
				timerReady = true;
			end;	
			if MultiOverlayV3.timers["1sec"] == nil then --default Timers 1-60 sec. Add over MultiOverlayV3
				for a=1, moGeneralSettings.maxTimers do
					MultiOverlayV3.timers[tostring(a).. "sec"] = {current_time = 0, delay = a*1000, onOff= true, action = nil, repeatable = true, runs = true};
				end;				
			end;
			if MultiOverlayV3.timers["1mSec"] == nil then --default Timers 1-60 Milli-sec. Add over MultiOverlayV3
				for a=1, moGeneralSettings.maxTimers do
					MultiOverlayV3.timers[tostring(a).. "mSec"] = {current_time = 0, delay = a*100, onOff= true, action = nil, repeatable = true, runs = true};
				end;				
			end;
		end;
		if timerReady then 
			MultiOverlayV3.timers[args.name] = {current_time = 0, delay = delay, action = action, onOff = true, repeatable = repeatable, runs = true}; --with Timer Name (runs = true/false,set auto over Timers)
			return true;
		else 
			return false, "addTimer... Table name=.... not found/incorrect(needs string) or name already exists";
		end;
	end;
	return false, "addTimer... Table not Found or not a Table";
end;

function moSetGetExtras:update_timers(dt)
	if MultiOverlayV3.timers ~= nil then
		for name, timer in pairs(MultiOverlayV3.timers) do
			if MultiOverlayV3.timers[name] ~= nil then --for delete -timer check
				timer.current_time = timer.current_time + dt;
				if timer.current_time > timer.delay then
					if timer.onOff then timer.onOff = false;else timer.onOff = true;end; --onOff 1xon 1xoff all ..sec
					timer.runs = false; --1x all ..sec, blink effect oder auslöser						 
					if timer.action then timer.action();end;            
					if timer.repeatable then 
						if type(timer.repeatable) == "number" then
							timer.repeatable = timer.repeatable - 1
							if timer.repeatable >= 0 then 
								timer.current_time = 0;							
							else 
								MultiOverlayV3.timers[name] = nil; 
							end;
						else 
							timer.current_time = 0;						
						end;
					else
						MultiOverlayV3.timers[name] = nil;
					end;
				else
					timer.runs = true;
				end;
			end;
		end;
	end;
end;

function moSetGetExtras:runsTimer(name, onOff)
	if name == nil or type(name) ~= "string" then return nil;end;	
	if MultiOverlayV3.timers ~= nil and MultiOverlayV3.timers[name] ~= nil then		
		if onOff ~= nil and onOff then
			return MultiOverlayV3.timers[name].onOff, MultiOverlayV3.timers[name].repeatable;
		else
			return MultiOverlayV3.timers[name].runs, MultiOverlayV3.timers[name].repeatable;
		end;
	end;
	return nil;
end;

function moSetGetExtras:removeTimer(name)
	if name == nil or type(name) ~= "string" then return nil;end;
	if MultiOverlayV3.timers ~= nil and MultiOverlayV3.timers[name] ~= nil then
		MultiOverlayV3.timers[name] = nil;
		return true;
	end;
	return nil;
end;
--new LS 19

--old LS 17
function moSetGetExtras:createTimers(self)	
	local lenght = 250;
	local isTimersLenght = 0;	
	moGeneralSettings.timer = {};
	for a=0, moGeneralSettings.maxTimers do		
		moGeneralSettings.timer["getTimer".. a] = 0;
		if a == 0 then
			moGeneralSettings.timer["isTimer".. a] = 250;
		else
			isTimersLenght = isTimersLenght+lenght;
			moGeneralSettings.timer["isTimer".. a] = isTimersLenght;
		end;		
	end;	
end;

function moSetGetExtras:setTimers(self)	
	for a=0,moGeneralSettings.maxTimers do
		moGeneralSettings.timer["getTimer".. a] = moGeneralSettings.timer["getTimer".. a]+1;
		if moGeneralSettings.timer["getTimer".. a] >= moGeneralSettings.timer["isTimer".. a] then
			moGeneralSettings.timer["getTimer".. a] = 0;			
		end;
	end;
end;

function moSetGetExtras:getTimer(self, timer, greater)	
	if greater and moGeneralSettings.timer["getTimer".. timer] >= moGeneralSettings.timer["isTimer".. timer]/2 then 
		return true;
	elseif greater == nil or not greater and moGeneralSettings.timer["getTimer".. timer] < moGeneralSettings.timer["isTimer".. timer]/2 then 
		return true;
	end;
	return false;
end;
--old LS 17

function moSetGetExtras:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours;end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

function moSetGetExtras:getRealTime(getHours, getMin, getSec)
	if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
	if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
	if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	return "0";
end;

function moSetGetExtras:optiHeightSize(self, height, txtString, defaultSize)
	local txtHeight = getTextHeight(defaultSize, tostring(txtString));
	local default = defaultSize;
	if txtHeight > height then
		local i = 0;
		while txtHeight > height do
			i = i + 0.0005;
			txtHeight = getTextHeight(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;	
	end;
	return default;
end;

function moSetGetExtras:getWidthOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function moSetGetExtras:getRandomColor(wert1, wert2)
	return random(wert1, wert2), random(wert1, wert2), random(wert1, wert2);
end;

--old later delete
moSetGetExtras.colors = {	
	own =       		{ 255/255, 255/255, 255/255, 1.00 };
	ownDisabled =   	{ 255/255, 255/255, 255/255, 0.80 };
	ownSilo =       	{ 	0/255,   0/255,   0/255, 1.00 };
	ownPrice =      	{ 255/255, 255/255, 255/255, 1.00 };
	ownBestPrice =  	{ 	0/255, 255/255,   0/255, 0.80 };
	ownDemand =     	{   4/255,  98/255, 180/255, 1.00 }; 	
	randomValues =  	{ 255/255, 255/255, 255/255, 1.00 };
	randomValuesOff =	{ 255/255, 255/255, 255/255, 0.80 };
	transparent =   	{  33/255,  48/255,  24/255, 0.50 };	
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };	
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 139/255, 1.00 };
	blue =	 			{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	darkRed = 			{ 205/255,   0/255,   0/255, 1.00 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{  69/255,  139/255,  0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	darkGray = 			{  87/255,  87/255,  87/255, 1.00 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	blackInactive = 	{ 	0/255,   0/255,   0/255, 0.75 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};

function moSetGetExtras:getAllowedCharacters()
	local allowedSpan = { from = 32, to = 591 };
	local prohibitedUnicodes = { [34] = true, [39] = true, [94] = true, [96] = true, [215] = true, [247] = true };
	for unicode=127,190 do
		prohibitedUnicodes[unicode] = true;
	end;
	local result = {};
	for unicode=allowedSpan.from,allowedSpan.to do
		prohibitedUnicodes[unicode] = prohibitedUnicodes[unicode] or false;
		result[unicode] = not prohibitedUnicodes[unicode] and getCanRenderUnicode(unicode);
		--if getCanRenderUnicode(unicode) then
			--print(string.format('allowedCharacters[%d]=%s (%q) (prohibited=%s, getCanRenderUnicode()=true)', unicode, tostring(result[unicode]), unicodeToUtf8(unicode), tostring(prohibitedUnicodes[unicode])));
			--print("-unicode:".. unicode, "-result:".. tostring(result[unicode]), "-unicodeToUtf8:".. unicodeToUtf8(unicode), "-prohibited..:".. tostring(prohibitedUnicodes[unicode]));
		--end;
	end;
	return result;
end;

function moSetGetExtras:getUtf8normalization()
	local result = {};
	local normalizationSpans = {
		a  = { {192,195}, 197, {224,227}, 229, {256,261} },
		ae = { 196, 198, 228, 230 },
		c  = { 199, 231, {262,269} },
		d  = { {270,273} },
		e  = { {200,203}, {232,235}, {274,283} },
		g  = { {284,291} },
		h  = { {292,295} },
		i  = { {204,207}, {236,239}, {296,307} },
		j  = { {308,309} },
		k  = { {310,312} },
		l  = { {313,322} },
		n  = { 209, 241, {323,331} },
		o  = { {210,213}, {242,245}, {332,337} },
		oe = { 214, 216, 246, 248, 338, 339 },
		r  = { {340,345} },
		s  = { {346,353}, 383 },
		ss = { 223 },
		t  = { {354,359} },
		u  = { {217,219}, {249,251}, {360,371} },
		ue = { 220, 252 },
		w  = { 372, 373 },
		y  = { 221, 253, 255, {374,376} },
		z  = { {377,382} }
	};
	for normal,unicodes in pairs(normalizationSpans) do
		for _,data in pairs(unicodes) do
			if type(data) == "number" then
				local utf8 = unicodeToUtf8(data);
				result[utf8] = normal;
				if false and getCanRenderUnicode(data) then
					--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
				end;
			elseif type(data) == "table" then
				for unicode=data[1],data[2] do
					local utf8 = unicodeToUtf8(unicode);
					result[utf8] = normal;
					if false and getCanRenderUnicode(unicode) then
						--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
					end;
				end;
			end;
		end;
	end;
	return result;
end;

function moSetGetExtras:onIsUnicodeAllowed(unicode)
	return MultiOverlayV3.allowedCharacters[unicode] == true;
end;