moMissionsConfig = {};

function moMissionsConfig:onStartMission()
	moMissions:load();
end;

function moMissionsConfig:defaultValues()
	moMissions.values = {missions={}, sortBy=1, updateTimer=10, msec=false};
	--sortBy 1=price, 2=typeId, 3=hectar, 4=field
end;

function moMissionsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moMissions.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moMissions.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moMissionsConfig:saveXml(self, Xml, xmlNameTag)
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moMissions.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moMissions.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moMissionsConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;