missions = {};

--needs missions
--lineType 2/missions
function missions:load()
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=3, txtScroll={leftRight=true,upDown=true}};
	if moMissions.values.missions ~= nil and #moMissions.values.missions > 0 then
		local deleteObject = {};
		lineTable[#lineTable+1] = {};
		isLineTable = lineTable[#lineTable];
		
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = missions.returnLineHelpIconClick
		isLineTable.helpTxt = "Click MissionName for MapHotSpot(Only FieldMissions) or % for FillType Category or Price\nOr Map Missions for Open Page Menue\nMowBale = #S for Silage and #H for Hay";		
		
		isLineTable.txt = {};
		isLineTable.txt[1] = {};									
		isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map Missions (".. tostring(#moMissions.values.missions).. ")";
		isLineTable.txt[1].txtPos = 1; --1 middle, 2 right, default left
		isLineTable.txt[1].clickCallback = missions.returnClickMissionsTotal;
		
		lineTable[#lineTable+1] = {};
		isLineTable = lineTable[#lineTable];		
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = missions.returnLineHelpIconSortByClick
		--isLineTable.helpTxt = "Click SortyBy ... for change";
		isLineTable.txt = {};
		isLineTable.txt[1] = {};									
		isLineTable.txt[1].clickCallback = missions.returnLineSortByClick;
		isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txtPos = 1; --1 middle, 2 right, default left		
		if moMissions.values.sortBy == 1 then
			isLineTable.txt[1].txt = "SortBy Price";
		elseif moMissions.values.sortBy == 2 then
			isLineTable.txt[1].txt = "SortBy Type";
		elseif moMissions.values.sortBy == 3 then
			isLineTable.txt[1].txt = "SortBy Hectar";
		else
			isLineTable.txt[1].txt = "SortBy Field";	
		end	
		local firstFarmIdPos = 3;		
		for index=1, #moMissions.values.missions do		
			if moMissions.values.missions[index] ~= nil then			
				local mission = moMissions.values.missions[index];
				local isRunning = mission.isRunning or (mission.status == AbstractMission.STATUS_RUNNING or mission.status == AbstractMission.STATUS_FINISHED);
				if isRunning and mission.farmId == playerFarmId then
					local txt = {};				
					table.insert(lineTable, firstFarmIdPos, txt);
					isLineTable = lineTable[firstFarmIdPos];					
				else
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];
				end;
				isLineTable.txt = {};
				isLineTable.txt[1] = {};									
				isLineTable.txt[1].width = 30;	--width prozent
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[1].bold = moModule.values.txtBold;				
				isLineTable.txt[1].txt = g_i18n:formatMoney(mission.reward)..  moLanguageXml:getTxt("moneysymbol", nil, "€");
				if mission.missionId ~= nil and mission.missionId > 0 then
					isLineTable.txt[1].clickCallback = missions.returnClickMissionsMoney;
					isLineTable.txt[1].missionId = mission.missionId;	
				end;
				isLineTable.txt[2] = {};									
				isLineTable.txt[2].width = 50;	--width prozent
				if isRunning then
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtActiveColor);
				else
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
				end;				
				local fillTypeMission = "";
				if mission.field ~= nil and mission.fillType ~= nil and tostring(mission.typeName):lower() == "mow_bale" then
					if mission.fillType == FillType.SILAGE then fillTypeMission = "#S";else fillTypeMission = "#H";end;
				end;
				isLineTable.txt[2].bold = moModule.values.txtBold;				
				isLineTable.txt[2].txt = tostring(mission.className).. fillTypeMission;				
				if moModule.values.languageXml then
					isLineTable.txt[2].txt = moLanguageXml:getTxt("mission".. tostring(mission.typeName):lower(), nil, mission.className).. fillTypeMission;
				end;				
				if mission.numObjects ~= nil and mission.numObjects > 0 then
					isLineTable.txt[2].txt = isLineTable.txt[2].txt.. " (".. tostring(mission.numObjects).. ")"
				elseif mission.field ~= nil and mission.fieldId > 0 then
					isLineTable.txt[2].txt = isLineTable.txt[2].txt.. " (F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ha";
				end;
				if mission.isLeasing then isLineTable.txt[2].txt = "L#"..isLineTable.txt[2].txt;end; 
				if mission.field ~= nil then
					isLineTable.txt[2].field = mission.field;
					isLineTable.txt[2].clickCallback = missions.returnClickMissionsName;
					isLineTable.txt[2].txtPos = 3; --1 middle, 2 right, default left	
				end;
				if mission.sellPointId ~= nil then
					isLineTable.txt[2].sellPointId = mission.sellPointId;
					isLineTable.txt[2].clickCallback = missions.returnClickMissionsName;
				end;
				isLineTable.txt[3] = {};									
				isLineTable.txt[3].width = 20;	--width prozent
				isLineTable.txt[3].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[3].bold = moModule.values.txtBold;
				isLineTable.txt[3].txt = tostring(mission.prozent).. "%";
				if mission.field ~= nil and mission.fillType ~= nil then
					isLineTable.txt[3].clickCallback = missions.returnClickMissionsFillType;
					isLineTable.txt[3].fillTypeName = moFillTypes.values.fillTypes[mission.fillType].name;
				end;
				if isRunning and mission.farmId ~= playerFarmId then --hidden					
					local farmColor = missions:getColorForFarm(mission.farmId)
					isLineTable.txt[1].txt = "-"
					isLineTable.txt[1].bold = false;
					isLineTable.txt[1].clickCallback = nil;
					isLineTable.txt[2].txt = "----"
					isLineTable.txt[2].bold = false;
					isLineTable.txt[2].color = farmColor;
					isLineTable.txt[2].clickCallback = nil;
					isLineTable.txt[3].txt = "-"
					isLineTable.txt[3].bold = false;
					isLineTable.txt[3].clickCallback = nil;
				elseif mission.status == AbstractMission.STATUS_FINISHED then					
					isLineTable.txt[3].txt = "Finsih";
				--elseif isRunning and mission.status == AbstractMission.STATUS_STOPPED then					
				--	isLineTable.txt[3].txt = "Cancel";	
				end;
			end;
		end;		
	end;	
	missions.output= lineTable;
end;

function missions.returnClickMissionsTotal(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			g_gui:showGui("InGameMenu");
			local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
			local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
			g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);
		end;
	end;
end;		

function missions.returnClickMissionsMoney(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			if g_currentMission.inGameMenu.pageContracts == nil then return;end;
			local missionId = missions.output[args.line].txt[1].missionId;
			g_gui:showGui("InGameMenu");
			local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
			local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
			g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);
			local selectMission = g_currentMission.inGameMenu.pageContracts.contractsList:getSelectedDataIndex();
			if g_currentMission.inGameMenu.pageContracts.contracts[selectMission] ~= nil and g_currentMission.inGameMenu.pageContracts.contracts[selectMission].mission.id ~= missionId then
				for a=1, #g_currentMission.inGameMenu.pageContracts.contracts do
					if g_currentMission.inGameMenu.pageContracts.contracts[a] ~= nil and g_currentMission.inGameMenu.pageContracts.contracts[a].mission.id == missionId then
						g_currentMission.inGameMenu.pageContracts.contractsList:setSelectedIndex(a);
						return;
					end;
				end;
			end;
		end;
	end;
end;

function missions.returnClickMissionsFillType(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			local fillTypeName = missions.output[args.line].txt[3].fillTypeName;
			g_currentMission:showBlinkingWarning("Mission FillType: ".. tostring(fillTypeName), 2000);
		end;
	end;
end;

function missions.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(missions.output[args.line].helpTxt);
		end;
	end;
end;

function missions.returnLineHelpIconSortByClick(...)	
	if ... ~= nil then		
		local args = ...;		
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.txt = "Click SortyBy ... for change\nand wait for the timer query\n(xml settings module missions updtaeTimer value)";		
	end;
end;

function missions.returnLineSortByClick(...)
	if ... ~= nil then		
		local args = ...;
		if moMissions.values.sortBy+1 > 4 then moMissions.values.sortBy = 1;else moMissions.values.sortBy = moMissions.values.sortBy+1;end;				
	end;
end;

function missions.returnClickMissionsName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil then			
			--Field:getCenterOfFieldWorldPosition			
			if missions.output[args.line].txt[2].field ~= nil then
				local x = missions.output[args.line].txt[2].field.posX;
				local z = missions.output[args.line].txt[2].field.posZ;
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot(nil, x, z);
				end;
			end;
			if missions.output[args.line].txt[2].sellPointId ~= nil then
				local x, y, z = getWorldTranslation(missions.output[args.line].txt[2].sellPointId);				
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot(nil, x, z, true);
				end;
			end;
		end;		
	end;
end;

function missions.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.missions.isRunning = true;moModule.active.missions.last = moModule.time.min+moModule.time.delay;		
		missions:load();
		return missions.output;				
	end;
end;

function missions.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--missions:load();	
end;

function missions:generateCmd()
	local _, errorTable = 0, {};
	function insertCmd()
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };		
		newCmdTable.cmdTable[1] = {
			cmdName = "mapMissions";
			displayName = "Map Missionen";		
			multiple = true;
			sortBy = "Missionen";
			infoTxt = "Zeigt alle missionen an";
			helpTxt = "View missions";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 3;
			typ = "output";
			action = missions.giveOutputTable; --a function
			ownValues = {}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate mapMissions Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;	 
	local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "mapMissions", "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
	if isAlreadyExits == nil then insertCmd();end;		
end;

function missions:getColorForFarm(farmId)
    local farm = g_farmManager:getFarmById(farmId);
    if farm ~= nil then
        local color = Farm.COLORS[farm.color];
        if color ~= nil then
            return {color[1], color[2], color[3], color[4]};
        end;
    end;
    return {1, 1, 1, 1};
end;
